var MailData = {
    myName      : null,
    myAddress   : null,
    toName      : null,
    toAddress   : null,
    mailContent : null,
    subject     : "Request for a gift",
    attachment  : null,
    attachedURL : "http://www.amazon.com/"
};

function initMailData() {
    if ( window.widget ) {
        var myname = _makeLocalizedName( SimpleABAccess.getMyFirstName(), SimpleABAccess.getMyLastName() );
        MailData.myName = myname;
        var myaddress = SimpleABAccess.getMyEmail();
        MailData.myAddress = myaddress;
        MailData.toAddress = widget.preferenceForKey( "ANGEL" );
        MailData.toName = widget.preferenceForKey( "ANGEL_NAME" );
        var content = widget.preferenceForKey( "MAIL_CONTENT" );
        //debug( "angel " + MailData.toName + " " + MailData.toAddress );
        if ( content ) {
            MailData.mailContent = content;
        } else {
            try {
                MailData.mailContent = localizedStrings[ "letterContents" ];
            } catch ( e ) {
                MailData.mailContent = document.getElementById( "letterContent" ).value;
            }
        }
        document.getElementById( "letterContent" ).value = MailData.mailContent;

    }
}

function _makeLocalizedName( firstname, lastname ) {
    if ( firstname == null && lastname == null ) return null;
    if ( firstname == null ) firstname == "";
    if ( lastname == null ) lastname == "";
    try {
        if ( Country == "JP" || Country == "KR" || Country == "CH" ) {
            return lastname + " " + firstname;
        } else {
            return firstname + " " + lastname;
        }
    } catch ( e ) {
        return firstname + " " + lastname;
    }
}

function sendMail() {
    setTimeout( _sendMail, 0 );
}

function sendMail() {
    try {
        //debug( SimpleABAccess.sendMailViaAppleScript );
        try {
            MailData.subject = localizedStrings[ "Subject" ];
        } catch ( e ) {
        }

        var content = MailData.toName + "\n\n" + MailData.mailContent + "\n" + MailData.attachedURL + "\n\n" + MailData.myName;
        //debug( "URL : " + MailData.attachedURL );
        widget.openApplication( "com.apple.dock" );
        SimpleABAccess.sendMailViaAppleScript( content, MailData.subject, MailData.toAddress, MailData.toName );

    } catch ( e ) {
        debug( e );
    }
}

function sendMail_old() {
    var LineSeparator = "__**__";
    var lines = MailData.mailContent.split( "\n" );
    var contents = lines[ 0 ];
    for ( var i = 1; i < lines.length; i++ ) {
        contents += LineSeparator + lines[ i ];
    } 
    if ( MailData.attachedURL ) {
        contents += LineSeparator + LineSeparator + MailData.attachedURL + LineSeparator;
    }
    contents += MailData.myName + LineSeparator;
    var mailcommand = '/usr/bin/osascript sendmail.scpt "' 
        + MailData.myAddress + '" "' 
        + MailData.toName + '" "'
        + MailData.toAddress + '" "'
        + contents + '" "'
        + MailData.subject + '"';
    if ( MailData.attachment ) {
        mailcommand += ' "' + MailData.attachment + '"';
    }
    debug( mailcommand );
    widget.openApplication( "com.apple.dock" );
    var com = widget.system( mailcommand, mailEndHandler );
}

function mailEndHandler( command ) {
    if ( command.errorString ) {
        debug( command.errorString );
    }
    debug( command.outputString );
}


var addressUnselectedStyle = { color:"white", background:"none" };
var addressSelectedStyle   = { color:"black", background:"white" };
//var selectedAngel = null;
var selectedAngel = { firstName:null, lastName:null, email:null };

function createAddressSelection() {
    var angel_id = -1;
    if ( window.widget ) {
        //var angel = widget.preferenceForKey( "ANGEL" );
        var angel = MailData.toAddress;//selectedAngel.email;//;
        if ( angel ) {
            for ( var i = 0; i < SimpleABAccess.getSize(); i++ ) {
                var address = SimpleABAccess.getEmailAddresses( i ).split( "," )[ 0 ];
                if ( address == angel ) {
                    angel_id = i;
                    break;
                }
            }
        }
    }

    //debug( "Angel id " + angel_id + " " + MailData.toAddress );

    //document.getElementById( "behind" ).style.display = "block";
    var table = document.getElementById( "angelAddress" );
    while ( table.lastChild ) table.removeChild( table.lastChild );
    var select = table;//document.createElement( "select" );
    select.style.width = "270px";
    //select.setAttribute( "id", "angelList" );
    //select.addEventListener( "change", selectAngel, true );
    //table.appendChild( select );
    if ( angel_id < 0 ) {
        var unselected = document.createElement( "option" );
        unselected.innerText = "---";
        select.appendChild( unselected );
    }
    for ( var i = 0; i< SimpleABAccess.getSize(); i++ ) {
        var firstname =  SimpleABAccess.getFirstName( i );
        var lastname =  SimpleABAccess.getLastName( i );
        var addresses = SimpleABAccess.getEmailAddresses( i ).split( "," );
        var option = document.createElement( "option" );
        if ( angel_id == i ) {
            var angel_name = _makeLocalizedName( firstname, lastname );
            debug( "SELECTED ANGEL : " + angel_name + ", " + addresses[ 0 ] );
            selectedAngel = { firstName:firstname, lastName:lastname, email:addresses[ 0 ] };
            option.setAttribute( "selected" );
            try {
                MailData.toName = angel_name;//firstname + " " + lastname;
                MailData.toAddress = addresses[ 0 ];
            } catch ( e ) {
                debug( e );
            }
        }
        option.setAttribute( "value", i );
        option.innerText = _makeLocalizedName( firstname, lastname ) + " <" + addresses[ 0 ] + ">";
        select.appendChild( option );

//         var row = document.createElement( "div" );
//         row.setAttribute( "class", "angel" );
//         row.addressId = i;
//         row.addEventListener( "click", selectAngel, true );
//         table.appendChild( row );
//         var td = document.createElement( "span" );
//         td.setAttribute( "class", "angelName" );
//         td.innerText = firstname + " " + lastname;
//         row.appendChild( td );
//         var td2 = document.createElement( "span" );
//         td2.setAttribute( "class", "angelEmail" );
//         td2.innerText = addresses[ 0 ];
//         row.appendChild( td2 );
    }
//     var ascroller = newScroller( "addressBook", "addressTable", "addressTrack", "addressThumb" );
    //document.getElementById( "behind" ).style.display = "none";

    if ( window.widget ) {
        var mail_content = widget.preferenceForKey( "MAIL_CONTENT" );
        var textarea = document.getElementById( "letterContent" );
        if ( textarea ) {
            if ( mail_content ) {
                while( textarea.firstChild ) textarea.removeChild( textarea.firstChild );
                textarea.appendChild( document.createTextNode( mail_content ) );
            }
            MailData.mailContent = getInnerText( textarea );
        }
    }
    MailData.myName    = _makeLocalizedName( SimpleABAccess.getMyFirstName(), SimpleABAccess.getMyLastName() );
    MailData.myAddress = SimpleABAccess.getMyEmail();
    debug( "my email " + MailData.myAddress + " " + MailData.myName );
}

function selectAngel( event ) {
    var select = document.getElementById( "angelAddress" );//List" );
    if ( select == null ) {
        debug( "no selection" );
        return;
    }
    var id = parseInt( select.value );
    if ( id == undefined ) {
        debug( "no id" );
        return;
    }

    var firstname =  SimpleABAccess.getFirstName( id );
    var lastname =  SimpleABAccess.getLastName( id );
    var addresses = SimpleABAccess.getEmailAddresses( id ).split( "," );
    selectedAngel = { firstName:firstname, lastName:lastname, email:addresses[ 0 ] };
    var angel_name = _makeLocalizedName( firstname, lastname );
    MailData.toName    = angel_name;

    MailData.toAddress = selectedAngel.email;//addresses[ 0 ];
    debug( angel_name + " " + addresses );//firstname + " " + lastname + " " + addresses );

}
